;   Nokia 1110 96*72  
;  -  96  -   8 .  0   .
;  96  -  8 . 
;>>     4-  .<<   
; ,  

.include "m32def.inc"
.def tmp    = r19
.def tmp1   = r20
.def loop   = r21

// LCD
.equ   lcd_clk = PB0 // Lcd clock 
.equ   lcd_dat = PB1 // Lcd data
.equ   lcd_CS  = PB2 // crystal select  
.equ   lcd_res = PB3 // reset chip

.CSEG ;Code segment

;Interrupt vectors:
.org 0
	rjmp Init	   ;reset vector

Init:
      cli                  ; 
      ldi tmp,low(RAMEND)  ;  
      out SPL,tmp
      ldi tmp,high(RAMEND) ;  
      out SPH,tmp

	  ldi tmp,(1<<lcd_clk)|(1<<lcd_dat)|(1<<lcd_CS)|(1<<lcd_res)
	  out ddrb,tmp   
	  ldi tmp,(1<<lcd_clk)|(1<<lcd_dat)|(1<<lcd_CS)|(1<<lcd_res)
	  out portb,tmp  

//    
	ldi tmp,0xE2 // Internal reset 
	rcall lcd_cmd
	ldi tmp,0xEB //    
	rcall lcd_cmd
	ldi tmp,0x2F //   
	rcall lcd_cmd
	ldi tmp,0xA1 //  LSB -> MSB 
	rcall lcd_cmd
	ldi tmp,0xA4 //     
	rcall lcd_cmd
	ldi tmp,0xA6 //   
	;ldi tmp,0xA7 //   
	rcall lcd_cmd
	ldi tmp,0xAF //   
	rcall lcd_cmd
 
main:
//****************************************************
	ldi    xl,low (96)    //  
	ldi    xh,high(96)    // 
cl:                  // 
	ldi    tmp,255 
	rcall  out_byte        // 
	sbiw   xl,1            //  
	brne   cl

zz:
rjmp zz 
//*****************************************************

lcd_cmd:               // Send command to LCD
	cbi    portb,lcd_CS    // select chip 
	cbi    portb,lcd_dat    //  
	sbi    portb,lcd_clk   // CLK -> 1 
 rjmp ob
out_byte:              // Send command to LCD
	cbi    portb,lcd_CS    // select chip  
	sbi    portb,lcd_dat    //   
	sbi    portb,lcd_clk   // CLK -> 1 
	nop                    // 
	nop                    // 
ob:
	cbi     portb,lcd_clk  // CLK -> 0 
lcd_cm:
	ldi     loop,8         // 
outs12:                //   
	clc                    // 
	rol     tmp            // 
	brcc    noc2           // 
	sbi     portb,lcd_dat  // DATA=1
	rjmp    drdy2          // 
noc2:                  // 
	cbi     portb,lcd_dat  // DATA=0
drdy2:                 //  
	nop                    // 
	sbi     portb,lcd_clk  // CLK -> 1 
	nop                    // 
	nop                    // 
	cbi     portb,lcd_clk  // CLK -> 0 
	dec     loop           // 
	brne    outs12         //  
	sbi    portb,lcd_CS    // select chip  
	clc	
ret                    // 


wait_10us:
	ldi tmp,2
wt: 
    dec tmp
	brne wt
ret


